<template>
	<div>
		<div class="cards">
			<h4>Event bearbeiten</h4>
			<div class="card-body">
				<form v-on:submit.prevent class="cols c-0-1 mobile-flex">
					<div class="cell">Titel</div>
					<div class="cell">
						<input ref="title"  v-model="eventToEdit.title" type="text" class="input" required />
					</div>
					<div class="cell">Typ</div>
					<div class="cell">
						<select ref="eventTypeId" v-model="eventToEdit.eventTypeId" class="input" required>
							<option v-for="eventType in allEventTypes" :key="eventType.id" :value="eventType.id">
								{{ eventType.title }}
							</option>
						</select>
					</div>
					<div class="cell">Start</div>
					<div class="cell">
						<input @change="forceDateCorrection" ref="dateStart" v-model="eventToEdit.dateStart" class="input" type="date" name="dateStart" required />
					</div>
					<div class="cell">Ende</div>
					<div class="cell">
						<input @change="forceDateCorrection" ref="dateEnd" v-model="eventToEdit.dateEnd" class="input" type="date" name="dateEnd" required />
					</div>
					<div class="cell">Einlass</div>
					<div class="cell">
						<input ref="doorsOpen" v-model="eventToEdit.doorsOpen" class="input" type="time" name="doorsOpen" required />
					</div>
					<div class="cell">Preis</div>
					<div class="cell">
						<input ref="price" v-model="eventToEdit.price" class="input" type="number" name="price" required />
					</div>
					<div class="cell">Flyer</div>
					<div class="cell">
						<input ref="image" @change="uploadFlyer" class="input" type="file" name="image" :required="!eventToEdit.image" />
						<img v-if="eventToEdit.image" :src="baseUrl + '/program/' + eventToEdit.image" title="Flyer Preview" alt="Flyer preview" class="flyer-upload-preview" />
					</div>
					<div class="cell">Text</div>
					<div class="cell">
						<textarea ref="text" v-model="eventToEdit.text" class="input input--full-w" name="text" required></textarea>
					</div>

					<div class="cell c-merged button-row">
						<button @click="updateEvent" type="submit" class="button button--mobile-stretch">Speichern</button>
						<button @click="$router.back()" class="button button--mobile-stretch">Abbrechen</button>
					</div>
				</form>
			</div>
		</div>
		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>
</template>

<script>
import SystemMessage from "@/components/SystemMessage";

export default {
	name: "AdminEventsEdit",
	components: { SystemMessage },
	props: {
		id: String
	},
	data: () => ({
		eventToEdit: {
			id: 0,
			title: "",
			eventTypeId: "",
			dateStart: "",
			dateEnd: "",
			doorsOpen: "",
			price: "",
			image: "",
			text: ""
		},
		sysMsg: undefined
	}),
	methods: {
		async updateEvent() {
			let verified = this.globalValidateForm();
			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			if(this.eventToEdit.doorsOpen.length < 8) {
				this.eventToEdit.doorsOpen += ":00";
			}

			try {
				const response = await this.$http.put("/api/admin/events/update", this.eventToEdit);
				switch (response.status) {
					case 200:
						this.sysMsg = "Event erfolgreich gespeichert!";
						this.globalResetFormValidation();
						break;
					case 202:
						this.sysMsg = "Datum nicht verfügbar!";
						this.$refs.dateStart.classList.add("input--alert");
						this.$refs.dateEnd.classList.add("input--alert");
						this.$refs.dateStart.focus();
						break;
				}
			} catch (e) {
				if (e.response.status === 404) {
					this.sysMsg = "Kategorie nicht gefunden!";
				}
			}
		},

		async uploadFlyer() {
			const file = this.$refs.image.files[0];
			let formData = new FormData();
			formData.append("file", file);

			try {
				const response = await this.$http.post("/api/admin/events/upload", formData)

				switch (response.status) {
					case 200:
						this.sysMsg = "Flyer erfolgreich hochgeladen!";
						this.eventToEdit.image = file.name;
						this.$refs.image.classList.remove("input--alert");
						break;
				}
			} catch (e) {
				switch (e.response.status) {
					case 413:
						this.sysMsg = "Datei ist zu groß!";
						this.$refs.image.classList.add("input--alert");
						this.$refs.image.value = "";
						break;
				}
			}
		},

		async fetchEvent() {
			const response = await this.$http.get("/api/event/" + this.id);
			for (let key of Object.keys(response.data)) {
				if (this.eventToEdit[key] !== undefined) {
					this.eventToEdit[key] = response.data[key];
				}
			}
			this.eventToEdit.eventTypeId = response.data.eventType.id;
		},

		forceDateCorrection() {
			let dateStart = this.$refs.dateStart;
			let dateEnd = this.$refs.dateEnd;
			if (!!dateStart || !!dateEnd) {
				if (dateStart.value > dateEnd.value) {
					dateEnd.value = dateStart.value;
					this.eventToEdit.dateEnd = dateStart.value;
				}
			}
		}
	},
	computed: {
		allEventTypes() {
			return this.$store.getters.getAllEventTypes;
		},
		baseUrl() {
			return process.env.VUE_APP_BASE_URL;
		}},
	mounted() {
		this.$store.dispatch("getAllEventTypes");
		this.fetchEvent();
	}
}
</script>

<style scoped>

</style>